<?
// phasi.php3 : PHP Another System Info
// written under Gpl by guido@technojuice.com
//
// Credits:
//  Uriah Welcome (precision@linux.com) author hardware code phpSysInfo
//  J.P. Pasnak <pasnak@warpedsystems.sk.ca> author memory code
//
//

// info time host
$time = (exec("date"));


//info uptime
$uptime_info = "Uptime:" . trim(exec("uptime")) . "\n\n";


// RAM Info
$memory_info = ". " . round(filesize("/proc/kcore") / 1024 / 1024) . "  MB\n";


// Global Hardware Info

//info cpu(s)
$cpuinfo = file("/proc/cpuinfo");
for ($i = 0; $i < count($cpuinfo); $i++) {
                list($item, $data) = split(":", $cpuinfo[$i], 2);
                $item = chop($item);
                $data = chop($data);
                if ($item == "processor") {
                                $total_cpu++;
                                $cpu_info = $total_cpu;
                }
                if ($item == "vendor_id") { $cpu_info .= $data; }
                if ($item == "model name") { $cpu_info .= $data; }
                if ($item == "cpu MHz") {
                                $cpu_info .= " " . floor($data);
                                $found_cpu = "yes";
                }
                if ($item == "cache size") { $cache = $data;}
                if ($item == "bogomips") { $bogomips = $data;}
}
if($found_cpu != "yes") { $cpu_info .= " <b>unknown</b>"; }
$cpu_info .= " MHz Processor(s)\n";

// end cpu



// peraph devices


// variables to dysplay devices
$show_ttyinfo    =        "yes";
$show_fdcinfo    =        "yes";
$show_floppy     =        "yes";
$show_graphics   =        "yes";
$show_eth        =        "yes";
$show_scsi       =        "yes";
$show_pci        =        "yes";
$show_ide        =        "yes";
$show_raid       =        "yes";

// Parsing function
function parse_stuff ($counter, $splitter, $data, $tailer) {
        if ($counter) {
                $this_line = split($splitter, $data);
                $this_line[1] = chop($this_line[1]);
                return "$counter $this_line[1] $tailer\n";
        }
}

// Parse the output 'dmesg' looking for what's installed
exec("dmesg | grep -v Rx", $dmesg);
for ($i = 0; $i < count($dmesg); $i++) {
        // scsi info
        if (strstr($dmesg[$i], "scsi : detected")) {
                list($a, $scsi_temp) = split("detected", $dmesg[$i], 2);
                $dmesg_scsi_str = trim($scsi_temp);
        // tty info
        } elseif (strstr($dmesg[$i], "tty")){
                $tty++;
                $dmesg_tty_str = $dmesg[$i];
        // floppy controller info
        } elseif (strstr($dmesg[$i], "FDC")) {
                $fdc++;
                $dmesg_fdc_str = $dmesg[$i];
        // floppy drive info
        } elseif (strstr($dmesg[$i], "Floppy")) {
                $floppy++;
                $dmesg_floppy_str = $dmesg[$i];
        // ethernet info
        } elseif (strstr($dmesg[$i], "eth") && strstr($dmesg[$i], " at ")) {
                $eth++;
                $dmesg_eth_str[$eth] = $dmesg[$i];
        // IDE Devices
        } elseif (ereg("^hd[a-z]", $dmesg[$i])) {
                $ide++;
                $dmesg_ide_array[$ide - 1] = $dmesg[$i];
        // Raid Devices
        } elseif (ereg("^DAC960", $dmesg[$i])) {
                $raid++;
                $dmesg_raid_array[$raid - 1] = $dmesg[$i];
        }
}

// Parse out TTY Information
if ($show_ttyinfo == "yes") { $tty_info = parse_stuff($tty, "is a ", $dmesg_tty_str, " port(s)"); }

// Parse out FDC Information
if ($show_fdcinfo == "yes") { $fdc_info = parse_stuff($fdc, "is a ", $dmesg_fdc_str, "floppy controller(s)"); }

// Parse out Floppy Information
if ($show_fdcinfo == "yes") { $floppy_info = parse_stuff($floppy, "is ", $dmesg_floppy_str, "Floppy Drive(s)"); }

// Parse out /proc/ioports and print vga info
if ($show_graphics = "yes") {
        $ioports = file("/proc/ioports");
        for ($i = 0; $i < count($ioports); $i++) {
                if (strstr($ioports[$i], "vga")) {
                        $vga++;
                        $vga_info = $ioports[$i];
                }
        }
        $graphics_info = parse_stuff($vga, " : ", $vga_info, "graphics devices(s)");
}

// Parse out Ethernet Information
if ($show_eth == "yes" && $dmesg_eth_str) {
        $eth_info = "$eth ethernet interface(s)\n";
        for ($i = 1; $i <= $eth; $i++) {
                $eth_info .= "  $dmesg_eth_str[$i]\n";
        }
}

// Parse out SCSI Information
if ($show_scsi == "yes" && $dmesg_scsi_str) {
        $scsi_info = eregi_replace(" total.", "", $dmesg_scsi_str) . "\n";
        $scsi = file("/proc/scsi/scsi");
        for ($i = 0; $i < count($scsi); $i++) {
                if (strstr($scsi[$i], "Vendor")) {
                        list($a, $vendor, $model) = split(":", $scsi[$i]);

                        $vendor = trim(eregi_replace("Model", "", $vendor));
                        $model = trim(eregi_replace("Rev", "", $model));
                        if (strlen($vendor) < 6) {
                                $scsi_info .= "  $vendor                 $model\n";
                        } else {
                                $scsi_info .= "  $vendor         $model\n";
                        }
                }
        }
}

// Parse out IDE Information
if ($show_ide == "yes" && count($dmesg_ide_array)) {
        $ide_info = $ide/2 . " IDE Device(s)\n";
        for ($i = 0; $i < count($dmesg_ide_array); $i++) {
                // Because dmesg lists the device type first and info we want after that
                if ($i >= $ide/2) {
                        $ide_info .= "  " . chop($dmesg_ide_array[$i]) . "\n";
                }
        }
}

// Parse out /proc/pci
if ($show_pci == "yes") {
        if (file_exists("/sbin/lspci")) {
                exec("lspci", $pci);
                $pci_info = "PCI bus devices:\n";
                for ($i = 0; $i < count($pci); $i++) {
                        $this_line = split(" ", $pci[$i], 2);
                        $pci_info .= "  " . chop($this_line[1]) . "\n";
                }
        } else {
                $pci = file("/proc/pci");
                $pci_info = "PCI bus devices:\n";
                for ($i = 0; $i < count($pci); $i++) {
                        if (strstr($pci[$i], "Bus")) {
                                $pci_info .= chop("  " . trim($pci[$i+1])) . "\n";
                        }
                }
        }
}


//Get the memory info
$meminfo = file("/proc/meminfo");
for ($i = 0; $i < count($meminfo); $i++) {
                list($item, $data) = split(":", $meminfo[$i], 2);
                $item = chop($item);
                $data = chop($data);
                if ($item == "MemTotal") { $total_mem =$data;        }
                if ($item == "MemFree") { $free_mem = $data; }
                if ($item == "SwapTotal") { $total_swap = $data; }
                if ($item == "SwapFree") { $free_swap = $data; }
                if ($item == "Buffers") { $buffer_mem = $data; }
                if ($item == "Cached") { $cache_mem = $data; }
                if ($item == "MemShared") {$shared_mem = $data; }
}
$used_mem = ( $total_mem - $free_mem );
$used_swap = ( $total_swap - $free_swap );
$percent_free = round( $free_mem / $total_mem * 100 );
$percent_used = round( $used_mem / $total_mem * 100 );
$percent_swap = round( ( $total_swap - $free_swap ) / $total_swap * 100 );
$percent_swap_free = round( $free_swap / $total_swap * 100 );
$percent_buff = round( $buffer_mem / $total_mem * 100 );
$percent_cach = round( $cache_mem / $total_mem * 100 );
$percent_shar = round( $shared_mem / $total_mem * 100 );
// end mem. info


//Partitions parse
exec ("df", $x);
$count = 1;
while ($count < sizeof($x)) {
                list($drive[$count], $size[$count], $used[$count], $avail[$count], $percent[$count], $mount[$count]) = split(" +", $x[$count]);
                $percent_part[$count] = str_replace( "%", "", $percent[$count] );
$count++;
}






// HTML output
include("include-en.inc");

?>